/* 
   $Id: sgbarwindow.h,v 1.3 2001/12/25 05:15:34 sho Exp $

   Copyright (C) 2001,2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of sgwm.

   sgwm is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sgwm is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sgwm; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef __SGBARWINDOW_H__
#define __SGBARWINDOW_H__

typedef struct _SGBarWindow SGBarWindow;
typedef struct _SGBarWindowClass SGBarWindowClass;

#include <gdk/gdk.h>
#include <gtk/gtkwidget.h>
#include "sgwmwidget.h"
#include "sgwindow.h"

#define SGBARWINDOW(obj) (GTK_CHECK_CAST((obj),GTK_TYPE_SGBARWINDOW,SGBarWindow))
#define SGBARWINDOW_CLASS(klass) (GTK_CHECK_CLASS_CAST((klass),\
	GTK_TYPE_SGBARWINDOW,SGBarWindow))
#define IS_SGBARWINDOW(obj) (GTK_CHECK_TYPE((obj),GTK_TYPE_SGBARWINDOW))

#define GTK_TYPE_SGBARWINDOW (sgbarwindow_get_type())

struct _SGBarWindow {
    SGWindow sgwin;
    gint16 x;
    gboolean moved;
};

#define SGBARWINDOW_APP 0
#define SGBARWINDOW_MENUBAR 1
#define SGBARWINDOW_TOOLBAR 2

struct _SGBarWindowClass {
    SGWindowClass parent_class;
};

extern GtkType sgbarwindow_get_type(void);
extern GtkWidget *sgbarwindow_new(guint32 xid, SGWMWidget *sgwm, gint type);
extern GtkWidget *sgbarwindow_lookup(guint32 xid, SGWMWidget *sgwm, gint type);

#endif
