/* 
   $Id: sgsendcmsg.c,v 1.3 2001/12/25 05:15:35 sho Exp $

   Copyright (C) 2001,2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of sgwm.

   sgwm is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sgwm is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sgwm; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "sgwm.h"
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <stdio.h>
#include <stdlib.h>

void usage(char *cmd)
{
    fprintf(stderr,"Usage:%s messagetype arg1 arg2 ...\n",cmd);
    exit(2);
}

int main(int argc, char **argv)
{
    Atom atom;
    Display *dpy;
    int i;
    XClientMessageEvent ev;

    if ((dpy = XOpenDisplay(NULL)) == NULL) {
	fprintf(stderr,"Can't open display\n");
	exit(2);
    }
    if (argc < 2) {
	usage(argv[0]);
    }
    atom = XInternAtom(dpy,argv[1],False);
    ev.type = ClientMessage;
    ev.window = DefaultRootWindow(dpy);
    ev.message_type = atom;
    ev.format = 32;
    for (i = 2;i < argc;i++) {
	ev.data.l[i-2] = atoi(argv[i]);
    }
    XSendEvent(dpy,DefaultRootWindow(dpy),False,
      SubstructureNotifyMask,(XEvent *)&ev);
    XSync(dpy,False);
    return 0;
}
