/* 
   $Id: sgwindow.h,v 1.6 2001/12/27 06:15:00 sho Exp $

   Copyright (C) 2001,2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of sgwm.

   sgwm is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sgwm is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sgwm; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef __SGWINDOW_H__
#define __SGWINDOW_H__

typedef struct _SGWindow SGWindow;
typedef struct _SGWindowClass SGWindowClass;

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <gdk/gdk.h>
#include <gtk/gtkwidget.h>
#include "sgwmwidget.h"

#define SGWINDOW(obj) (GTK_CHECK_CAST((obj),GTK_TYPE_SGWINDOW,SGWindow))
#define SGWINDOW_CLASS(klass) (GTK_CHECK_CLASS_CAST((klass),\
	GTK_TYPE_SGWINDOW,SGWindow))
#define IS_SGWINDOW(obj) (GTK_CHECK_TYPE((obj),GTK_TYPE_SGWINDOW))

#define GTK_TYPE_SGWINDOW (sgwindow_get_type())

#define SGWINDOW_DESTROYED(sgwin) (GTK_WIDGET(sgwin)->window == NULL)

struct _SGWindow {
    GtkWidget widget;
    SGWMWidget *sgwm;
    gint8 type;
    gint8 workspace;
    guint8 border_width;
};

#define SGWINDOW_APP 0
#define SGWINDOW_MENUBAR 1
#define SGWINDOW_TOOLBAR 2
#define SGWINDOW_NUNOME 3

struct _SGWindowClass {
    GtkWidgetClass parent_class;
};

extern GtkType sgwindow_get_type(void);
extern GtkWidget *sgwindow_new(guint32 xid, SGWMWidget *sgwm);
extern GtkWidget *sgwindow_setup(SGWindow *sgwin, guint32 xid, SGWMWidget *sgwm);
extern GtkWidget *sgwindow_lookup(guint32 xid, SGWMWidget *sgwm);
extern GtkWidget *sgwindow_from_gdk_window(GdkWindow *win, guint32 xid,
  SGWMWidget *sgwm);
extern void sgwindow_destroy_notify(SGWindow *win);
extern void sgwindow_get_bars(SGWindow *sgwin, GtkWidget **menubar,
  GtkWidget **toolbar);
extern void sgwindow_move(SGWindow *sgwin, gint x, gint y);
extern void sgwindow_raise(SGWindow *sgwin);
extern void sgwindow_resize(SGWindow *sgwin, gint w, gint h);
extern void sgwindow_move_resize(SGWindow *sgwin,
  gint x, gint y, gint w, gint h);
extern void sgwindow_change_wm_state(SGWindow *sgwin, int state);
extern Window sgwindow_get_transient_for(SGWindow *sgwin);
extern gboolean sgwindow_is_same_leader(SGWindow *sgwin1, SGWindow *sgwin2);
extern void sgwindow_set_focus(SGWindow *sgwin);
extern void sgwindow_set_workspace_property(SGWindow *sgwin, guint32 val);
extern gint sgwindow_get_workspace_property(SGWindow *sgwin);
extern XWMHints *sgwindow_get_wm_hints(SGWindow *sgwin);
extern void sgwindow_get_geometry(SGWindow *sgwin, gint *x, gint *y,
  gint *w, gint *h, gint *bw);
extern gboolean sgwindow_get_normal_hints(SGWindow *sgwin, XSizeHints *hints);
extern void sgwindow_configure(SGWindow *sgwin, GtkAllocation *alloc,
  gint border_width, Window sibling, gint stack_mode, gint value_mask);
extern void sgwindow_get_position(SGWindow *sgwin, gint *x, gint *y);

#endif
